<template>
  <div class="total-energy-modal flex flex-col justify-between h-full">
    <div class="flex justify-between">
      <div class="text-xl font-semibold">Energy kWh (Summary)</div>

      <div class="flex items-center gap-4">
        <img
          :src="require('~/assets/images/Export Pdf.svg')"
          alt="Export Pdf.svg"
          class="cursor-pointer"
        />

        <img
          :src="require('~/assets/images/Xls Export.svg')"
          alt="Xls Export.svg"
          class="cursor-pointer"
        />

        <img
          :src="require('~/assets/images/Export CSV.svg')"
          alt="Export CSV.svg"
          class="cursor-pointer"
        />

        <div class="relative">
          <img
            :src="require('~/assets/images/filter while 1.svg')"
            alt="filter while 1.svg"
            class="cursor-pointer ml-6 w-[100px]"
            @click="show_filter = !show_filter"
          />

          <div
            v-if="show_filter"
            class="absolute top-10 right-0 bg-darkblue border border-primary p-4 rounded-md w-[270px] shadow"
          >
            <div class="text-xl font-semibold text-primary">กรองข้อมูล</div>

            <div class="font-light mt-4">
              <div>เวลาเริ่มต้น</div>

              <input
                type="datetime-local"
                v-model="form.start_date"
                class="w-full px-3 py-1 text-black rounded-md mt-1 focus:outline-none"
              />

              <div class="mt-2">เวลาสิ้นสุด</div>

              <input
                type="datetime-local"
                v-model="form.end_date"
                class="w-full px-3 py-1 text-black rounded-md mt-1 focus:outline-none"
              />
            </div>

            <button
              class="bg-primary text-white px-8 py-1 rounded-md block mt-4 mx-auto"
              @click="changeFilter"
            >
              กรอง
            </button>
          </div>
        </div>
      </div>
    </div>

    <div class="h-[500px] mt-40">
      <canvas id="total-energy"></canvas>
    </div>
  </div>
</template>

<script>
import Chart from "chart.js/auto";
import _ from "lodash";

export default {
  props: {
    light_data: {
      type: Array,
      default: () => {
        return [];
      },
    },
  },
  data() {
    return {
      chart: null,
      chart_data: [],
      show_filter: false,
      form: {
        start_date: "",
        end_date: "",
      },
    };
  },
  mounted() {
    this.setChart();
  },
  methods: {
    setChart() {
      this.chart_data = [...this.light_data];
      const ctx = document.getElementById(`total-energy`);

      const options = {
        maintainAspectRatio: false,
        plugins: {
          tooltip: {
            enabled: false,
          },
          legend: {
            display: false,
          },
        },
        scales: {
          x: {
            grid: {
              display: false,
              drawBorder: false,
            },
          },
          y: {
            grid: {
              display: false,
              drawBorder: false,
            },
          },
        },
      };

      const data = {
        labels: _.map(this.chart_data, (d) => [d.date, d.time]),
        datasets: [
          {
            data: _.map(this.chart_data, (d) => d.energy),
            borderColor: "#00D1E3",
            pointRadius: 0,
          },
        ],
      };

      const config = {
        type: "line",
        data,
        options,
      };

      Chart.defaults.font.family = "Kanit";
      Chart.defaults.font.size = 12;
      Chart.defaults.color = "white";
      Chart.defaults.font.weight = 300;
      this.chart = new Chart(ctx, config);
    },
    async changeFilter() {
      this.show_filter = false;

      // set mock data
      this.chart_data = [
        {
          name: "Light001",
          status: true,
          hour: 8519,
          energy: 4101,
          date: "Apr 26",
          time: "12:00",
          light_step: 100,
          time_list: [
            {
              open: "",
              close: "",
            },
            {
              open: "",
              close: "",
            },
          ],
          group: {
            id: 1,
            name: "หาดพลา",
          },
          position: {
            name: "หาดพยูน",
            lat: 13.736717,
            lng: 100.523186,
            address: "ถนนเทศบาล 46 ตำบลบ้านฉาง  อำเภอบ้านฉาง จังหวัดระยอง",
          },
          statistic: {
            energy_data: [
              {
                value: 110,
                date: "Apr 26",
                time: "12:00",
              },
              {
                value: 210,
                date: "Apr 27",
                time: "12:00",
              },
              {
                value: 810,
                date: "Apr 28",
                time: "12:00",
              },
            ],
            intensity_data: [
              {
                value: 810,
                date: "Apr 26",
                time: "12:00",
              },
              {
                value: 210,
                date: "Apr 27",
                time: "12:00",
              },
              {
                value: 410,
                date: "Apr 28",
                time: "12:00",
              },
            ],
          },
          id: 1,
          changing_list: [
            {
              name: "dasdas",
              datetime: "2009-06-15T13:45:30",
            },
          ],
        },
        {
          id: 2,
          name: "Light002",
          status: true,
          hour: 8519,
          energy: 1101,
          date: "Apr 26",
          time: "12:00",
          light_step: 100,
          time_list: [
            {
              open: "",
              close: "",
            },
            {
              open: "",
              close: "",
            },
          ],
          group: {
            id: 2,
            name: "หาดพลา2",
          },
          position: {
            name: "หาดพยูน",
            lat: 13.6626,
            lng: 100.4375,
            address: "ถนนเทศบาล 46 ตำบลบ้านฉาง  อำเภอบ้านฉาง จังหวัดระยอง",
          },
          statistic: {
            energy_data: [
              {
                value: 210,
                date: "Apr 26",
                time: "12:00",
              },
              {
                value: 210,
                date: "Apr 27",
                time: "12:00",
              },
            ],
            intensity_data: [
              {
                value: 210,
                date: "Apr 26",
                time: "12:00",
              },
              {
                value: 210,
                date: "Apr 27",
                time: "12:00",
              },
            ],
          },
          changing_list: [
            {
              name: "dsdasd",
              datetime: "2009-06-15T13:45:30",
            },
          ],
        },
        {
          id: 3,
          name: "Light003",
          status: true,
          hour: 8519,
          energy: 10101,
          date: "Apr 26",
          time: "12:00",
          light_step: 100,
          time_list: [
            {
              open: "",
              close: "",
            },
            {
              open: "",
              close: "",
            },
          ],
          group: {
            id: 2,
            name: "หาดพลา2",
          },
          position: {
            name: "หาดพยูน",
            lat: 13.6626,
            lng: 100.4375,
            address: "ถนนเทศบาล 46 ตำบลบ้านฉาง  อำเภอบ้านฉาง จังหวัดระยอง",
          },
          statistic: {
            energy_data: [
              {
                value: 210,
                date: "Apr 26",
                time: "12:00",
              },
              {
                value: 210,
                date: "Apr 27",
                time: "12:00",
              },
            ],
            intensity_data: [
              {
                value: 210,
                date: "Apr 26",
                time: "12:00",
              },
              {
                value: 510,
                date: "Apr 27",
                time: "12:00",
              },
            ],
          },
          changing_list: [
            {
              name: "dsadsa",
              datetime: "2009-06-15T13:45:30",
            },
          ],
        },
      ];

      // call api
      // this.chart_data = 'api_data'

      this.updateChart();
    },
    updateChart() {
      this.chart.data.datasets = [
        {
          data: _.map(this.chart_data, (d) => d.energy),
          borderColor: "#00D1E3",
          pointRadius: 0,
        },
      ];

      this.chart.data.labels = _.map(this.chart_data, (d) => [d.date, d.time]);
      this.chart.update();
    },
  },
};
</script>

<style lang="scss" scoped></style>
